﻿#ifndef DOORS_H
#define DOORS_H

#include "../common/sources/Map.h"
#include "walls.h"

struct SDoorElem
{
    char    file[32];           // nom de fichier
    int16_t x, y;               // position
    int16_t cx1, cy1, cx2, cy2; // rectangle de clipping
};

class CDoors
{
public:
    CDoors();
    bool    isFacing(CTile* tile);
    void    draw(QImage* image, CTile* tile, CVec2 tablePos);
    void    readDoorsDB();

private:
    struct CDoorData
    {
        QString files[3];
    };

    void    drawFrameElement(QImage* image, CVec2 tablePos, SDoorElem table[WALL_TABLE_HEIGHT][WALL_TABLE_WIDTH], bool isFlipped);
    void    drawDoor(QImage* image, CVec2 tablePos, std::string fileName);

    std::vector<CDoorData>  doorsDatas;
};

extern CDoors   doors;

#endif // DOORS_H
