#include "mouse.h"
#include "bridge.h"

CMouse  mouse;

//-----------------------------------------------------------------------------------------
CMouse::CMouse()
{
    mPos = CVec2();
    mButtonPressing = false;
    mButtonReleasing = false;
    mButtonPressed = false;
}

//-----------------------------------------------------------------------------------------
void CMouse::update()
{
    mPos = bridge.mMousePos;
    mButtonPressing = (mButtonPressed == false && bridge.mMouseButton == true);
    mButtonReleasing = (mButtonPressed == true && bridge.mMouseButton == false);
    mButtonPressed = bridge.mMouseButton;
}

//-----------------------------------------------------------------------------------------
void CMouse::clearAreas()
{
    mAreaList.clear();
}

//-----------------------------------------------------------------------------------------
void CMouse::addArea(EMouseAreaTypes type, CRect rect, void* param1, void* param2)
{
    SMouseArea  newArea;
    newArea.type = type;
    newArea.rect = rect;
    newArea.param1 = param1;
    newArea.param2 = param2;

    mAreaList.push_back(newArea);
}

//-----------------------------------------------------------------------------------------
SMouseArea* CMouse::clickedArea()
{
    if (mButtonPressed == true)
    {
        for (int i = mAreaList.size() - 1; i >= 0; --i)
        {
            CRect*  rect = &mAreaList[i].rect;

            if (mPos.x >= rect->tl.x &&
                mPos.y >= rect->tl.y &&
                mPos.x <= rect->br.x &&
                mPos.y <= rect->br.y)
            {
                return &mAreaList[i];
            }
        }
    }
    return NULL;
}
